///
/// @file       ParticleImage.cpp
/// @author     Armin Co
/// 

#include "ParticleImage.hpp"
#include "Common.hpp"

using namespace QPong;

constexpr int bytesPerPixel = 3;
constexpr int bitsPerSample = 8;

ParticleImage::ParticleImage()
    : ImageBuffer()
{

    m_pixbuf = new uChar[QPong::arraySize * bytesPerPixel];
}

Glib::RefPtr<Gdk::Pixbuf> ParticleImage::getPixbuf()
{
    for (unsigned i = 0; i < QPong::arraySize * bytesPerPixel;)
    {
        QColor c = getValue(i/bytesPerPixel);
        m_pixbuf[i++] = static_cast<uChar>(c.r * 255);
        m_pixbuf[i++] = static_cast<uChar>(c.g * 255);
        m_pixbuf[i++] = static_cast<uChar>(c.b * 255);
    }

    Glib::RefPtr<Gdk::Pixbuf> pb = Gdk::Pixbuf::create_from_data(m_pixbuf, Gdk::Colorspace::COLORSPACE_RGB, false, bitsPerSample, QPong::arrayWidth, QPong::arrayHeight, QPong::arrayWidth * bytesPerPixel);
    pb = pb->scale_simple(768, 768, Gdk::InterpType::INTERP_NEAREST);
    return pb;
}