///
/// @file       ParticleImage.hpp
/// @author     Armin Co
///
/// @brief      Class to wrap one dimensional array.
///

#ifndef QPONG_PARTICLE_IMAGE_HPP
#define QPONG_PARTICLE_IMAGE_HPP

#include <gtkmm.h>

#include "ImageBuffer.hpp"



/// @brief  Wraps an one dimensional array.
///         Values can be accessed as in 2D.
///
class ParticleImage : public QPong::ImageBuffer
{
public:
    ParticleImage();

    Glib::RefPtr<Gdk::Pixbuf> getPixbuf();

private:
    using uChar = unsigned char;
    uChar* m_pixbuf;
};

#endif