///
/// @file       QDrawingArea.cpp
/// @author     Armin Co
///

#include "QDrawingArea.hpp"


QDrawingArea::QDrawingArea()
{
    m_dispatcher.connect(sigc::mem_fun(*this, &QDrawingArea::queue_draw));
}


void QDrawingArea::redraw()
{
    m_dispatcher.emit();
}


void QDrawingArea::setPixbuf(Glib::RefPtr<Gdk::Pixbuf> pixbuf)
{
    m_image = pixbuf;
}


bool QDrawingArea::on_draw(const Cairo::RefPtr<Cairo::Context> &cr)
{
    cr->save();
    if (!m_image)
    {
        return true;
    }

    Gdk::Cairo::set_source_pixbuf(cr, m_image, 0, 0);
    cr->paint();
    cr->restore();
    return true;
}
