///
/// @file       Qlayer.hpp
/// @author     Armin Co
/// 
/// @brief      Player class.
///

#ifndef QPONG_QPLAYER_HPP
#define QPONG_QPLAYER_HPP

namespace QPong {

/// @brief Class wraps all values of one Player.
/// 
class Player
{
public:
    enum class Id
    {
        One,
        Two
    };


    struct Position
    {
        double x;
        double y;
    };


    enum class Direction
    {
        Up,
        Down
    };


    Player(Id pl, Position pos);
    void update(double dt);
    void move(Direction d);
    void addScore(float score);
    void reset();
    float getScore();
    Position getPosition();

private:
    Id m_id;
    double m_x;
    double m_y;
    double m_vx = 0;
    double m_vy = 0;
    double m_score = 0;
};

} // namespace QPong

#endif